<?php

namespace Drupal\mollie_commerce\PluginForm\OffsiteRedirect;

use Drupal\commerce_payment\PluginForm\PaymentOffsiteForm;
use Drupal\Core\Form\FormStateInterface;
use Drupal\mollie\Entity\Payment;

/**
 * Class MolliePaymentOffsiteForm.
 *
 * @package Drupal\mollie_commerce\PluginForm\OffsiteRedirect
 */
class MolliePaymentOffsiteForm extends PaymentOffsiteForm {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $formState) {
    $form = parent::buildConfigurationForm($form, $formState);

    /** @var \Drupal\commerce_payment\Entity\PaymentInterface $payment */
    $payment = $this->entity;
    // Initialize the Mollie payment.
    $transaction = Payment::create([
      'amount' => $payment->getAmount()->getNumber(),
      'currency' => $payment->getAmount()->getCurrencyCode(),
      // TODO: Better description.
      'description' => "Order #{$payment->getOrder()->id()}",
      'context' => 'mollie_commerce',
      'context_id' => $payment->getOrderId(),
    ]);
    // Create the Mollie payment.
    $transaction->save();

    // We should not catch the NeedsRedirectException here!
    return $this->buildRedirectForm(
      $form,
      $formState,
      $transaction->getCheckoutUrl(),
      []
    );
  }

}
